/*	Copyright 1992 H.Ogasawara (COR.)	*/
/*	modified 1998 by Shinichi Honma	*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	<microstr.h>
#include	"gview.h"

extern int	jpeg_info( char*, int*, int* );

#define		JPLOADER	"jpeged.r"
#define		JPOPTION	"-L0,0 -VS%d,%d,$"

GVIEW *
GV_Load_Jpeg( fname )
char	*fname;
{
	int	sizex, sizey;

	if( jpeg_info( fname, &sizex, &sizey ) ){
		GVIEW	*gp;
		unsigned char	line[256];
		if( !(gp= GV_Alloc( sizex, sizey, WindowAttrGraphic65536,
							fname, NULL, 0 )) ){
			GV_Err( "܂" );
			return	NULL;
		}else {
			unsigned int	i, num= (int)gp->buf;
			unsigned char	*str, *ptr;
			s_format( line, JPOPTION, sizex, sizey );
			for( str= line; *str ; str++ );
			for( i= 0 ; i< 6 ; i++, num<<= 4 ){
				*str++= ((char*)"0123456789abcdef")
							[(num >>20)&15];
			}
			*str++= ' ';
			for( ptr= fname ; *ptr ; *str++= *ptr++ );
			*str++= '\0';
		}
		ConsoleOpen();
		if( WindowLoadExec( JPLOADER, line, NULL, ConsoleChar ) ){
			MFREE( gp );
			GV_Err2( JPLOADER, "sł܂ł" );
			return	NULL;
		}
		WindowScreenInit();
		return	gp;
	}
	GV_Err2( fname, "t@C܂" );
	return	NULL;
}
